
#include <stdio.h>

struct METEO
{
 unsigned char		giorno;
 unsigned char 	    mese;
 unsigned short 	anno;
 unsigned char 	    ora;
 unsigned char		minuti;
 unsigned char		secondi;
 float			    temperatura; // C
 unsigned short	    pressione;   // mbar
 unsigned char		umidita;     // %
};


int main(void)
{
 FILE *txt, *bin;
 struct METEO data;
 int n;

 bin = fopen("meteo.bin", "rb"); // apertura file binario in lettura
 if (bin == NULL)
   {
    printf("Errore aperture file binario/r/n");
    return 0;
   }
 txt = fopen("meteo.csv", "w"); // apertura file testuale in scrittura
 if (txt == NULL)
   {
    printf("Errore aperture file testuale/r/n");
    fclose(bin);
    return 0;
   }
 while (!feof(bin)) // verifica fine del file
      {
       n = fread(&data, sizeof(struct METEO), 1, bin); // lettura del record
       if (n == 1) // verifica lettura da file
         {
          /* scrittura riga file CSV */
          fprintf(txt,"%02i:%02i:%02i,",data.ora,data.minuti,data.secondi);
          fprintf(txt,"%i/%i/%i,",data.giorno,data.mese,data.anno);
          fprintf(txt,"%.1fC,",data.temperatura);
          fprintf(txt,"%imbar,",data.pressione);
          fprintf(txt,"%i%%\r\n",data.umidita);
         }
       else
           break; // interruzione della lettura del file
      }
 /* chiusura del file */
 fclose(bin);
 fclose(txt);
 return 1;
}
