
#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>

#define BLOCK_DIM 1024


int main (int argc, char* argv[])
{
 int src, dst;
 char buf[BLOCK_DIM];
 int n;

 if (argc != 3)
   {
    printf("Errore negli argomenti del programma\r\n");
    return 0;
   }
 src = open(argv[1], O_RDONLY); // apertura file origine
 if (src<=0)
   {
    printf("\"%s\" open failed!\r\n",argv[1]);
    return 0;
   }
 dst = open(argv[2], O_WRONLY|O_CREAT); // apertura file destinazione
 if (dst<=0)
   {
    printf("\"%s\" open failed!\r\n", argv[2]);
    return 0;
   }
 
 n = read(src,buf,BLOCK_DIM); // lettura primo blocco
 while (n>0)
      {
       write(dst, buf, n); // scrittura blocco
       n = read(src, buf, BLOCK_DIM); // lettura blocco
      }
 
 /* chiusura file origine e destinazione */
 close(src);
 close(dst);
 return 1;
}

