
#include <stdio.h>
#include <fcntl.h>
#include <io.h>

#define BLOCK_DIM 1024


void main (int argc, char* argv[])
{
 int fid;
 char buf[BLOCK_DIM];
 int i, n;
 unsigned char crc=0;

 if (argc != 2)
   {
    printf("Errore negli argomenti del programma\r\n");
    return;
   }
 fid = _open(argv[1], O_RDONLY); // apertura file
 if (fid<=0)
   {
    printf("\"%s\" open failed!\r\n",argv[1]);
    return;
   }

 n = _read(fid,buf,BLOCK_DIM); // lettura primo blocco
 while (n>0)
      {
       for (i=0; i<n; i++)
          crc = crc^buf[i]; // aggiornamento CRC
       n = _read(fid, buf, BLOCK_DIM); // lettura blocco
      }
 _close(fid); // chiusura file
 printf("CRC=%x\r\n",crc); // visualizzazione CRC
 return;
}
