
#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>


int main(int argc, char* argv[])
{
 int sorgente, destinazione;
 int in, out, n;
 char in_buffer[64], out_buffer[64];

 if (argc != 3)
   {
    printf("Errore: fornire i nomi dei file sorgente e destinazione come argomenti!\r\n");
    return 0;
   }

 sorgente = open(argv[1], O_RDONLY);
 if (sorgente < 0)
   {
    printf("Errore apertura file sorgente \"%s\"\r\n", argv[1]);
    return 0;
   }
 destinazione = open(argv[2], O_WRONLY | O_CREAT);
 if (destinazione < 0)
   {
    printf("Errore apertura file sorgente \"%s\"\r\n", argv[2]);
    close(sorgente);
    return 0;
   }

 while ((n = read(sorgente, in_buffer, sizeof(in_buffer))) > 0)
      {
       out = 0;
       for (in=0; in<n; in++)
          {
           if (in_buffer[in] == '\n')
	     {
	      out_buffer[out] = '\r'; // premette il carattere CR al carattere LF
	      out++;
	     }
           out_buffer[out] = in_buffer[in];
	   out++;
	  }
       write(destinazione, out_buffer, out);
      }
 close(sorgente);
 close(destinazione);
 return 1;
}

