
#include <stdio.h>
#include <fcntl.h>
#include <io.h>


void main(int argc, char* argv[])
{
 int sorgente, destinazione;
 int in, out, n;
 char in_buffer[64], out_buffer[128];

if (argc != 3)
   {
	printf("Errore: fornire i nomi dei file sorgente e destinazione come argomenti!\r\n");
	return;
   }

 sorgente = _open(argv[1], _O_RDONLY | _O_BINARY);
 if (sorgente < 0)
   {
	printf("Errore apertura file sorgente \"%s\"\r\n", argv[1]);
	return;
   }
 destinazione = _open(argv[2], _O_WRONLY | _O_CREAT | _O_BINARY);
 if (destinazione < 0)
   {
	printf("Errore apertura file sorgente \"%s\"\r\n", argv[2]);
	_close(sorgente);
	return;
   }

 while ((n = _read(sorgente, in_buffer, sizeof(in_buffer))) > 0)
      {
	   out = 0;
	   for (in=0; in<n; in++)
	      {
		   if (in_buffer[in] == '\n')
		    {
			 out_buffer[out] = '\r';  // premette carattere CR al carattere LF
			 out++;
			}
		   out_buffer[out] = in_buffer[in];
		   out++;
	      }
	   
	   _write(destinazione, out_buffer, out);
      }
 _close(sorgente);
 _close(destinazione);
}
